Summary:        An open source data binding framework for Java
Name:           castor
Version:        0.9.5
Release:        7%{?dist}
Epoch:          0
Group:          Development/Libraries/Java
License:        BSD and MPLv1.1 and W3C
URL:            http://castor.codehaus.org
Source0:        http://dist.codehaus.org/castor/0.9.5/castor-0.9.5-src.tgz
Patch0:         example-servletapi4.patch
Patch1:         example-servletapi5.patch
Patch2:         castor-build-xml.patch
BuildArch:      noarch
Requires:       adaptx
Requires:       jta
Requires:       ldapjdk
Requires:       log4j
Requires:       jakarta-oro
Requires:       regexp
Requires:       xerces-j2
BuildRequires:  adaptx
BuildRequires:  log4j
BuildRequires:  ant
BuildRequires:  jpackage-utils >= 0:1.5.16
BuildRequires:  jta
BuildRequires:  ldapjdk
BuildRequires:  jakarta-oro
BuildRequires:  regexp
BuildRequires:  xerces-j2
BuildRequires:  servlet25
BuildRequires:  junit

%description
Castor is an open source data binding framework for Java. It's basically
the shortest path between Java objects, XML documents and SQL tables.
Castor provides Java to XML binding, Java to SQL persistence, and more.

%package demo
Group:          Development/Java
Summary:        Demo for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       servlet25

%description demo
Demonstrations and samples for %{name}.

%package test
Group:          Development/Java
Summary:        Tests for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       junit

%description test
Tests for %{name}.

%package xml
Group:          Development/Libraries/Java
Summary:        XML support for %{name}.
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description xml
XML support for Castor

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package doc
Summary:        Documentation for %{name}
Group:          Development/Documentation

%description doc
Documentation for %{name}.

%prep
%setup -q
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;
perl -p -i -e 's|org.apache.xerces.utils.regex|org.apache.xerces.impl.xpath.regex|g;' \
src/main/org/exolab/castor/util/XercesRegExpEvaluator.java
find . -name "*.java" -exec perl -p -i -e 's|assert\(|assertTrue\(|g;' {} \;
find . -name "*.java" -exec perl -p -i -e 's|_test.name\(\)|_test.getName\(\)|g;' {} \;
find src/doc -name "*.xml" -exec perl -p -i -e 's|\222|&#x92;|g;' {} \;
%patch0
%patch1
%patch2

# Fix for wrong-file-end-of-line-encoding problem
for i in `find src/doc -iname "*.css"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.xsd"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.dtd"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.pdf"`; do sed -i 's/\r//' $i; done
for i in `find src/doc -iname "*.htm"`; do sed -i 's/\r//' $i; echo "" >> $i; done
sed -i 's/\r//' src/etc/README
sed -i 's/\r//' src/etc/LICENSE
sed -i 's/\r//' src/etc/CHANGELOG
sed -i 's/Class-Path: xerces.jar jdbc-se2.0.jar jndi.jar jta1.0.1.jar//' src/etc/MANIFEST.MF

%build
export ANT_OPTS=" -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 "
export CLASSPATH=%(build-classpath adaptx jta junit ldapjdk oro regexp servlet xerces-j2)
ant -buildfile src/build.xml jar
ant -buildfile src/build.xml examples
ant -buildfile src/build.xml CTFjar
ant -buildfile src/build.xml javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
install -m 644 dist/%{name}-%{version}-xml.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-xml.jar
install -m 644 dist/CTF-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-tests.jar

# examples (demo)
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
cp -pr build/examples/* $RPM_BUILD_ROOT%{_datadir}/%{name}/examples

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -pr build/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# do this last, since it will delete all build directories
export CLASSPATH=%(build-classpath log4j adaptx)
ant -buildfile src/build.xml doc

# like magic
%jpackage_script org.exolab.castor.builder.SourceGenerator %{nil} %{nil} xerces-j2:%{name} %{name}

%files
%defattr(-,root,root,-)
%doc src/etc/{CHANGELOG,LICENSE,README}
%attr(0755,root,root) %{_bindir}/%{name}
%{_javadir}/%{name}.jar
%dir %{_datadir}/%{name}

%files demo
%defattr(-,root,root,-)
%{_datadir}/%{name}/examples

%files test
%defattr(-,root,root,-)
%{_javadir}/%{name}-tests.jar

%files xml
%defattr(-,root,root,-)
%{_javadir}/%{name}-xml.jar

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}

%files doc
%defattr(-,root,root,-)
%doc build/doc/*

%changelog
* Wed Apr 20 2011 Alexander Kurtakov <akurtako@redhat.com> 0:0.9.5-7
- Update to current guidelines.
- Fix oro deps.

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:0.9.5-6.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:0.9.5-5.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri May 08 2009 Karsten Hopp <karsten@redhat.com> 0.9.5-4.1
- Specify source and target as 1.4 to make it build

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:0.9.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Jul  9 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0:0.9.5-3
- drop repotag
- fix license tag

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0:0.9.5-2jpp.8
- Autorebuild for GCC 4.3

* Wed Apr 18 2007 Permaine Cheung <pcheung@redhat.com> - 0:0.9.5-1jpp.8
- Update spec file as per fedora review process.

* Thu Aug 03 2006 Deepak Bhole <dbhole@redhat.com> - 0:0.9.5-1jpp.7
- Added missing requirements.

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> - 0:0.9.5-1jpp_6fc
- Rebuilt

* Thu Jul  20 2006 Deepak Bhole <dbhole@redhat.com> - 0:0.9.5-1jpp_5fc
- Added conditional native compilation.
- Added missing BR/R for log4j.

* Thu Jun  8 2006 Deepak Bhole <dbhole@redhat.com> - 0:0.9.5-1jpp_4fc
- Updated project URL -- fix for Bug #180586

* Wed Mar  8 2006 Rafael Schloming <rafaels@redhat.com> - 0:0.9.5-1jpp_3fc
- excluded s390[x] and ppc64 due to eclipse

* Mon Mar  6 2006 Jeremy Katz <katzj@redhat.com> - 0:0.9.5-1jpp_2fc
- stop scriptlet spew

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Jun 16 2005 Gary Benson <gbenson@redhat.com> 0:0.9.5-1jpp_1fc
- Build into Fedora.

* Fri Jun 10 2005 Gary Benson <gbenson@redhat.com>
- Remove jarfiles and classfiles from the tarball.

* Thu Jun  2 2005 Gary Benson <gbenson@redhat.com>
- Fix up (alleged) invalid characters in the documentation.

* Fri Jul 23 2004 Fernando Nasser <fnasser@redhat.com> 0:0.9.5-1jpp_3rh
- use servletapi5 instead of servletapi4

* Thu Mar 11 2004 Frank Ch. Eigler <fche@redhat.com> 0:0.9.5-1jpp_2rh
- try servletapi4 instead of servletapi3
- add example-servletapi4 patch

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> 0:0.9.5-1jpp_1rh
- RH vacuuming

* Tue Sep 09 2003 David Walluck <david@anti-microsoft.org> 0:0.9.5-1jpp
- 0.9.5

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> 0:0.9.4.3-2jpp
- use same lsapjdk package as tyrex

* Sat May 10 2003 David Walluck <david@anti-microsoft.org> 0:0.9.4.3-1jpp
- release
